////////////////////////////////////////////////////////////////////////////////
// AReflection Library
// Copyright (c) 2004 by Arne Adams
// Permission to use, copy, modify, distribute and sell this software for any 
//     purpose is hereby granted without fee, provided that the above copyright 
//     notice appear in all copies and that both that copyright notice and this 
//     permission notice appear in supporting documentation.
// The author makes no representations about the suitability of this software 
//     for any purpose. It is provided "as is" without express or implied 
//     warranty.
////////////////////////////////////////////////////////////////////////////////
#ifndef REFLIB_ITERTYPE_H_INC_
#define REFLIB_ITERTYPE_H_INC_

#include <boost/pending/ct_if.hpp>

#include "boost/type_traits/is_const.hpp"

// allows to use the same template for const and non-const containers
template<class Container> struct GetIterType
{
    enum {isconst = boost::is_const<Container>::value};  
    typedef typename boost::ct_if<(isconst != 0),
                                typename Container::const_iterator,
                                typename Container::iterator>::type
    type;
};

#endif 
