////////////////////////////////////////////////////////////////////////////////
// AReflection Library
// Copyright (c) 2004 by Arne Adams
// Permission to use, copy, modify, distribute and sell this software for any 
//     purpose is hereby granted without fee, provided that the above copyright 
//     notice appear in all copies and that both that copyright notice and this 
//     permission notice appear in supporting documentation.
// The author makes no representations about the suitability of this software 
//     for any purpose. It is provided "as is" without express or implied 
//     warranty.
////////////////////////////////////////////////////////////////////////////////
#ifndef REFLIB_RECORDTAGS_H_INC_
#define REFLIB_RECORDTAGS_H_INC_

#include <boost/type_traits/is_convertible.hpp>

#include <boost/pending/ct_if.hpp>

struct CompileTIterableObjectTag
{};

struct NotCompileTIterableObjectTag
{};
namespace refl
{
    template<class QueryThis,class TrueTag,class FalseTag> struct TagApplies
    {
        enum {value = boost::is_convertible<QueryThis,TrueTag>::value};  
        typedef typename boost::ct_if<(value != 0),
                                    TrueTag,
                                    FalseTag >::type
        type;
    };

    template<class T> struct IsCompiletimeIterable
    {
        typedef TagApplies<T,CompileTIterableObjectTag,NotCompileTIterableObjectTag>
            Impl;
        
        typedef typename Impl::type type;
        
        BOOST_STATIC_CONSTANT(int, value = Impl::value);
    };
}


#endif 
